      .386
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************
;     include files
;**********************************************************************     
      include \Masm32\INCLUDE\windows.inc
      include \Masm32\INCLUDE\user32.inc
      include \Masm32\INCLUDE\kernel32.inc
      include \Masm32\INCLUDE\comdlg32.inc
      include \Masm32\include\Comctl32.inc
      include \Masm32\INCLUDE\gdi32.inc

;**********************************************************************
;     libraries
;**********************************************************************
      includelib \Masm32\LIB\user32.lib
      includelib \Masm32\LIB\kernel32.lib
      includelib \Masm32\LIB\comdlg32.lib
      includelib \Masm32\lib\Comctl32.lib
      includelib \Masm32\LIB\gdi32.lib

;**********************************************************************
; Local prototypes
;**********************************************************************
        WinMain                 PROTO :DWORD
        SetToolTipText          PROTO :DWORD,:DWORD
        DisplayBmp              PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        WinProc                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        CreateToolBar           PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        wsprintfA               PROTO C :DWORD,:VARARG
        SetBmpColors            PROTO :DWORD

        wsprintf equ <wsprintfA>

;**********************************************************************
; Local macros
;**********************************************************************
include macros\macros.asm

;**********************************************************************
; Place all your Constance here.
;**********************************************************************
.const
ICO_MAINICON     equ 500

;**********************************************************************
; Inishilized DATA
;**********************************************************************
.data
Wwidth           dd 550
Wheight          dd 315
szClassName      db "Template_Class",0
szAppName        db "ToolBar Image Example.",0
szChangPassword  db "Change Password/Username.",0
szConfig         db "Change Configuration Settings.",0
szConnect        db "Connect To Server.",0
szDisconnect     db "Disconnect From The Server.",0
szSendMessage    db "Check Or Send A Private Message",0
szHelp           db "Help (How to work this thing.)",0
szExit           db "Exit This Thing.",0
WinClass            db "STATIC",0
hImage              dd 0
hBmp                dd 0
hImage1             dd 0

     TBStruct      dd 8
                      dd 49
                      dd offset szChangPassword
                      dd 50
                      dd offset szConfig
                      dd 51
                      dd offset szConnect
                      dd 52
                      dd offset szDisconnect
                      dd 53
                      dd offset szSendMessage
                      dd 54
                      dd offset szHelp
                      dd 55
                      dd offset szExit


        TBInfo        dd 49                 ;Button ID.
                      dd 0                  ;Image Index.
                      dd TBSTYLE_BUTTON     ;Button Styles.
                      dd 50
                      dd 1
                      dd TBSTYLE_BUTTON
                      dd 51
                      dd 2
                      dd BTNS_CHECK
                      dd 52
                      dd 3
                      dd TBSTYLE_BUTTON
                      dd 53
                      dd 4
                      dd TBSTYLE_BUTTON
                      dd 54
                      dd 5
                      dd TBSTYLE_BUTTON
                      dd 55
                      dd 6
                      dd TBSTYLE_BUTTON
                      dd 0FFFFFFFFh

;**********************************************************************
; Un-Inishilized DATA
;**********************************************************************
.data?
hWnd             dd ?
hInstance        dd ?
hIcon            dd ?
hToolBar         dd ?
.code
;**********************************************************************
; This is the start of the code section, here we get our Module Handle
; and start our Program.
;**********************************************************************
start:
      mov hInstance,FUNC(GetModuleHandle,NULL)
      invoke WinMain,hInstance 
      invoke ExitProcess,eax

;**********************************************************************
; This section creates the MAIN CLASS and the MAIN window.
; Then loops sending messages to our WinProc for Proccessing.
;**********************************************************************
WinMain proc hModule:DWORD

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG

      mov hIcon,FUNC(LoadIcon,hModule,ICO_MAINICON)    ; icon ID
      mov wc.cbSize,sizeof WNDCLASSEX
      mov wc.style,CS_BYTEALIGNCLIENT 
      mov wc.lpfnWndProc,offset WinProc
      mov wc.cbClsExtra,NULL
      mov wc.cbWndExtra,NULL
      m2m wc.hInstance,hModule
      mov wc.hbrBackground,COLOR_BTNFACE+1
      mov wc.lpszMenuName,NULL
      mov wc.lpszClassName,offset szClassName
      m2m wc.hIcon,hIcon
      mov wc.hCursor,FUNC(LoadCursor,NULL,IDC_ARROW)
      m2m wc.hIconSm,hIcon
      invoke RegisterClassEx, addr wc
      mov hWnd,FUNC(CreateWindowEx,WS_EX_LEFT,addr szClassName,addr szAppName,WS_SIZEBOX or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_POPUP or WS_VISIBLE ,10,10,Wwidth,Wheight,NULL,NULL,hModule,NULL)
      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd
      MSGLOOP msg
WinMain endp
;**********************************************************************
; This is the Main programs code area. all messages for this APP are
; recived here, or the main app.
;**********************************************************************
WinProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

          LOCAL rect   :RECT

          .if uMsg == WM_CREATE
          invoke CreateToolBar,hWin,48,48,addr TBInfo,4,CCS_ADJUSTABLE or WS_VISIBLE or WS_CHILD or TBSTYLE_TOOLTIPS or TBSTYLE_ALTDRAG or TBSTYLE_FLAT,750
          mov [hToolBar],eax
          invoke GetClientRect,hWin,addr rect
          sub rect.right,50
          push rect.right
          pop rect.left
          mov rect.top,0
          invoke DisplayBmp,hToolBar,rect.left,rect.top,800,850 
          mov [hImage1],eax

          .elseif uMsg == WM_PAINT


          .elseif uMsg == WM_COMMAND


          .elseif uMsg == WM_SIZE
             invoke SendMessage,hToolBar,TB_AUTOSIZE,0,0
             invoke GetClientRect,hWin,addr rect
             sub rect.right,50
             invoke SetWindowPos,hImage1,0,rect.right,0,0,0,SWP_NOSIZE
          .elseif uMsg == WM_CLOSE
                  invoke DestroyIcon,hIcon
                  invoke DestroyWindow,hWin
                  invoke DestroyWindow,hToolBar

          .elseif uMsg == WM_NOTIFY
                  invoke SetToolTipText,lParam,addr TBStruct    

          .elseif uMsg == WM_DESTROY
                  invoke PostQuitMessage,0
                  return 0
          .endif


          invoke DefWindowProc,hWin,uMsg,wParam,lParam
          ret
WinProc endp
.data
hModule             dd 0
hTbBmp              dd 0
.code

;*************************************************************************
;
;
;*************************************************************************
CreateToolBar proc hWin:DWORD,XButtonSize:DWORD,YButtonSize:DWORD,lpTBInfo:DWORD,
                   ButtonCount:DWORD,Styles:DWORD,BmpID:DWORD


    LOCAL bSize  :DWORD
    LOCAL tbab   :TBADDBITMAP
    LOCAL tbb    :TBBUTTON
    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL hFont  :DWORD
    LOCAL Rct    :RECT
    LOCAL hDC    :DWORD
    LOCAL Ps     :PAINTSTRUCT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

      invoke InitCommonControls

    invoke GetModuleHandle,NULL
    mov hModule, eax
    invoke LoadBitmap,hModule,BmpID
    mov hTbBmp,eax
        szText tbClass,"ToolbarWindow32"

        invoke CreateWindowEx,WS_EX_LEFT,
                              addr tbClass,
                              0,
                              Styles,
                              0,100,10,10,
                              hWin,NULL,
                              hModule,NULL

                              ;; or TBSTYLE_FLAT

        mov hToolBar, eax
    
        invoke SendMessage,hToolBar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
    
        ;; ---------------------------------------
        ;; Put width & height of bitmap into DWORD
        ;; ---------------------------------------
        mov  ecx,XButtonSize  ;; loword = bitmap Width
        mov  eax,YButtonSize  ;; hiword = bitmap Height
        shl  eax,16
        mov  ax, cx

        mov bSize,eax
    
        invoke SendMessage,hToolBar,TB_SETBITMAPSIZE,0,bSize
    
        invoke SetBmpColors,hTbBmp
        mov hTbBmp,eax
    
        mov tbab.hInst, 0
        m2m tbab.nID,hTbBmp
        invoke SendMessage,hToolBar,TB_ADDBITMAP,ButtonCount,ADDR tbab
    
        invoke SendMessage,hToolBar,TB_SETBUTTONSIZE,0,bSize
     
        mov tbb.fsState,   TBSTATE_ENABLED
        mov tbb.dwData,    0
        mov tbb.iString,   0
    ; -----------------------------------
    mov esi,lpTBInfo
NextTB:    
    mov eax,[esi]
    .if eax == 0ffffffffh
    jmp TBDone
    .endif
    add esi,4
    mov ebx,[esi]
    add esi,4
    mov tbb.iBitmap, ebx  ;; button  ID number
    mov tbb.idCommand, eax  ;; command ID number
    mov eax,[esi]
    mov tbb.fsStyle,al
    add esi,4
    push esi
    invoke SendMessage,hToolBar,TB_ADDBUTTONS,1,ADDR tbb
    pop esi
    jmp NextTB
    
TBDone:
    mov eax,[hToolBar]
    ret

CreateToolBar endp

;*************************************************************************
;
;
;*************************************************************************
SetBmpColors proc hBitmap:DWORD

    LOCAL mDC       :DWORD
    LOCAL hBrush    :DWORD
    LOCAL hOldBmp   :DWORD
    LOCAL hReturn   :DWORD
    LOCAL hOldBrush :DWORD

      invoke CreateCompatibleDC,NULL
      mov mDC,eax

      invoke SelectObject,mDC,hBitmap
      mov hOldBmp,eax

      invoke GetSysColor,COLOR_BTNFACE
      invoke CreateSolidBrush,eax
      mov hBrush,eax

      invoke SelectObject,mDC,hBrush
      mov hOldBrush,eax

      invoke GetPixel,mDC,1,1
      invoke ExtFloodFill,mDC,1,1,eax,FLOODFILLSURFACE

      invoke SelectObject,mDC,hOldBrush
      invoke DeleteObject,hBrush

      invoke SelectObject,mDC,hBitmap
      mov hReturn,eax
      invoke DeleteDC,mDC

      mov eax,hReturn

    ret

SetBmpColors endp
;*******************************************************************

SetToolTipText proc lplParam:DWORD,ToolTipStruct:DWORD 

           invoke GetModuleHandle,NULL
           mov hModule, eax
           mov edi,lplParam
           mov ebx,[lplParam]
           mov esi,ToolTipStruct
           mov ecx,[esi]
           add esi,4
           
FindToolButton:
           
		.if dword ptr [ebx+8] == TTN_NEEDTEXT
			mov edx,dword ptr [ebx+4]
                  mov eax,[esi]
			.if eax == edx
                        add esi,4
                        mov eax,[esi]
				      mov dword ptr [ebx+12], eax
                       ret
			.else
                  add esi,8
                  dec ecx
                  .if ecx != 0
                      jmp FindToolButton
                  .endif
           .endif
	.endif

           ret

SetToolTipText endp
;********************************************************************
;
;
;*******************************************************************
DisplayBmp proc hWin:DWORD,Xpos:DWORD,Ypos:DWORD,
                  ImageID:DWORD,ID:DWORD 

            invoke CreateWindowEx,WS_EX_LEFT,
                                  addr WinClass,NULL,
                                  WS_BORDER or WS_CHILD or WS_VISIBLE or SS_BITMAP,
                                  Xpos,Ypos,10,10,hWin,ID,
                                  hWnd,NULL

            mov hImage, eax

            invoke LoadBitmap,hInstance,ImageID
            mov hBmp, eax

            invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_BITMAP,hBmp

           mov eax,hImage
           ret

DisplayBmp endp
;********************************************************************


end start
